--[[
**********************************************************************
Pet Attack - Small addon that will insist you make your pet attack
while you are in combat.
**********************************************************************
This file is part of Pet Attack, a World of Warcraft Addon

Pet Attack is free software: you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation, either version 3 of the License, or (at your
option) any later version.

Pet Attack is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with Optimus Protestas.  If not, see
<http://www.gnu.org/licenses/>.

**********************************************************************
]]

PetAttackAddon = LibStub("AceAddon-3.0"):NewAddon("PetAttack", "AceEvent-3.0")

local L = LibStub("AceLocale-3.0"):GetLocale("PetAttack")

local mod = PetAttackAddon

-- Determine if Player has a permanent pet.
function mod:HasPermaPet()
--local InVehicle = UnitInVehicle("player")
   local _,class = UnitClass("player")
   if class == "WARLOCK" then
    return not GetSpellBookItemInfo("Grimoire of Sacrifice") -- Stops all warnings if Warlock has learned this spell.
   elseif class == "HUNTER" then
   return true
   elseif class == "MAGE" then
      return not not GetSpellBookItemInfo("Summon Water Elemental")
  -- elseif class == "MAGE" then  
  -- return not GetSpellBookItemInfo("Summon Water Elemental")then
	--  return false 
   elseif class == "DEATHKNIGHT" then
      return not not GetSpellBookItemInfo("Raise Dead")
   end
	  return false
end

-- Register for combat.
function mod:OnEnable()
   mod:RegisterEvent("PLAYER_REGEN_ENABLED")
   mod:RegisterEvent("PLAYER_REGEN_DISABLED")
end

--Set up warning frame:
function mod:OnInitialize()
   PAFrame = CreateFrame("Frame", "PAFrame", UIParent)
   PAFrame:SetWidth(450)
   PAFrame:SetHeight(50)
   PAFrame:SetPoint("CENTER", UIParent, "CENTER", 0, 200)
   PAFrame:Hide()

   PAFrame.label = PAFrame:CreateFontString(nil, "OVERLAY", "SystemFont_OutlineThick_WTF")
   PAFrame.label:SetAllPoints()
   local font, size, flags = PAFrame.label:GetFont()
   PAFrame.label:SetFont(font, size*1, flags)
   PAFrame.label:SetText(L["PET IS NOT ATTACKING!"])

--Make Draggable:
   PAFrame:EnableMouse(true)
   PAFrame:SetMovable(true)
   PAFrame:RegisterForDrag("LeftButton")
   PAFrame:SetScript("OnDragStart", PAFrame.StartMoving)
   PAFrame:SetScript("OnDragStop", PAFrame.StopMovingOrSizing)
   PAFrame:SetScript("OnHide", PAFrame.StopMovingOrSizing)    
end

--Check for combat:
function mod:PLAYER_REGEN_ENABLED()
   mod:StopReminding();
   mod:UnregisterEvent("UNIT_TARGET")
end

function mod:PLAYER_REGEN_DISABLED()
  if mod:HasPermaPet() then
      mod:StartReminding();
      mod:RegisterEvent("UNIT_TARGET")
  end
end

--Determine if warning is to be displayed.
function mod:UNIT_TARGET(event, unit)

   if unit == "pet" then
      local target = UnitExists("pettarget")
      if target and mod.isAnnoying then
	 mod:StopReminding()
      elseif not target and not mod.isAnnoying then
	 mod:StartReminding()
	  end
   end
end

local InVehicle = UnitInVehicle("player")
   if Invehicle then
	--mod:StopReminding()
	PAFrame:Hide()
   end
      	
function mod:StopReminding()
     mod.isAnnoying = false
     PAFrame:Hide()
end	

function mod:StartReminding()
   if not UnitExists("pettarget") then
     mod.isAnnoying = true
     PAFrame:Show()
	end
end